function [lamsR, lamsC, rconds]=tr_reson_oct05(neum_eigs, Ss, ND1, lam_range, ypart, lmin, lmax, lam_Npoints, lam_0)
%
% The code aims to find the number of eigenvalues embedded in the essential
% spectrum in the interval (((lam_range-1)*pi/2)^2,(lam_range*pi/2)^2), or
% the number of resonances whose real part lies in this range and whose
% imaginary part lies between -ypart and ypart.
% 
% Here lam_range must be a positive integer.
%
[N_eig, n_m]= size(Ss);
alphas=pi^2/4*(0:1:(n_m-1)).^2;
lbound=max(pi^2/4*(lam_range-1)^2,lmin);
ubound=min(pi^2/4*lam_range^2,lmax);

lams=linspace(lbound, ubound, lam_Npoints+2);
lams=lams(2:end-1);
lamsx = linspace(lbound,ubound,lam_Npoints+2);
lamsy = linspace(-ypart,ypart,lam_Npoints+2);
[lamsR, lamsC] = meshgrid(lamsx, lamsy);
%Es=zeros(n_m-lam_range,lam_Npoints);
%v=[zeros(lam_range,1);ones(n_m-lam_range,1)];
for k=1:length(lamsx)
	for j=1:length(lamsy)	
%		lam=lamsR(1,k)+i*lamsC(j,1);
        lam = lamsx(k) + i*lamsy(j);
		kappas=diag(-sqrt(alphas-lam));
		kappas(1:lam_range, 1:lam_range)=diag(sqrt(alphas(1:lam_range)-lam));
		Rr = (ND1 + (lam-lam_0)*Ss'*diag(1./((neum_eigs-lam).*(neum_eigs-lam_0)))*Ss)*kappas;
%        Rr = (Ss'*diag(1./((neum_eigs-lam)))*Ss)*kappas;
        rconds(j,k)=cond(Rr-diag(ones(size(Rr,1),1)));        
%		 ranks(i)=min(svd(Rr-diag(v)));
%		 R=Rr(lam_range+1:end, lam_range+1:end);
%        rconds(j,k)=cond(R-diag(ones(size(R,1),1)));        

    end;
end;
% close all;
% figure(1), clf, ...
% plot(lams'/pi^2, Es, 'r.'), hold on,
% plot([lbound,lbound]/pi^2, y_range, '--'), hold on,
% plot([ubound,ubound]/pi^2, y_range, '--'), hold on,
% plot([lbound,ubound]/pi^2, [1,1], ':', 'LineWidth', 2), hold on,
% nes=find(neum_eigs>=lbound & neum_eigs<=ubound);
% for i=1:length(nes)
%	plot([neum_eigs(nes(i)), neum_eigs(nes(i))]/pi^2, y_range, ':'), hold on;
% end, ylim(y_range), xlabel('\lambda/\pi^2', 'FontSize', 14);
%%%
%%%
%%%
%%% figure(2), clf,...
%%% plot(lams/pi^2, rconds, 'r-'), hold on,
%%% plot(lams/pi^2, ranks(i)/(n_m-lam_range), 'g-'), hold on,
%%% plot([lbound,lbound]/pi^2, y_range, '--'), hold on,
%%% plot([ubound,ubound]/pi^2, y_range, '--'), hold on,
%%% plot([lbound,ubound]/pi^2, [0,0], ':', 'LineWidth', 2), hold on,
%%% nes=find(neum_eigs>=lbound & neum_eigs<=ubound);
%%% for i=1:length(nes)
%%% 	plot([neum_eigs(nes(i)), neum_eigs(nes(i))]/pi^2, y_range, ':'), hold %%% on;
%%% end, ylim([- 0.1 1.1]), xlabel('\lambda/\pi^2', 'FontSize', 14);
%%% end, ylim('auto'), xlabel('\lambda/\pi^2', 'FontSize', 14);

